import { el } from "../dom.js";
import type * as figma from "../figma.js";
import { type Preferences } from "../preferences.js";
import { Signal } from "../signal.js";
import { type LoadedState, type State } from "../state.js";
type ElementChild = NonNullable<Parameters<typeof el>[2]>[number];
interface UIProps<T> {
    state: Signal<State<T>>;
    preferences: Signal<Readonly<Preferences>>;
    infoContents: (data: T) => ElementChild;
    frameCanvas: (data: T, selected: Signal<figma.Node | null>, loadedState: Signal<LoadedState>) => ElementChild;
    menuSlot?: (data: T) => ElementChild;
    caller: "frame" | "file";
}
export declare function ui<T>({ state: $state, preferences: $preferences, infoContents: createinfoContents, frameCanvas: createFrameCanvas, menuSlot: createMenuSlot, caller, }: UIProps<T>): Signal<HTMLElement>;
export {};
